"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yup = __importStar(require("yup"));
const CreditBasePaymentParamsSchema_1 = __importDefault(require("./CreditBasePaymentParamsSchema"));
const CreditOneTimePaymentParamsSchema_1 = __importDefault(require("./CreditOneTimePaymentParamsSchema"));
const _CreditDividePaymentParamsSchema = yup.object().shape({
    CreditInstallment: yup
        .string()
        .strict()
        .max(20)
        .oneOf(['3', '6', '12', '18', '24', '30N']),
});
const _CreditPeriodPaymentParamsSchema = yup.object().shape({
    PeriodAmount: yup.number().integer().strict(),
    PeriodType: yup.string().strict().max(1).oneOf(['D', 'M', 'Y']),
    Frequency: yup
        .number()
        .integer()
        .strict()
        .min(1)
        .when('PeriodType', {
        is: 'D',
        then: (schema) => schema.max(365),
    })
        .when('PeriodType', {
        is: 'M',
        then: (schema) => schema.max(12),
    })
        .when('PeriodType', {
        is: 'Y',
        then: (schema) => schema.max(1),
    }),
    ExecTimes: yup
        .number()
        .integer()
        .strict()
        .min(1)
        .when('PeriodType', {
        is: 'D',
        then: (schema) => schema.max(999),
    })
        .when('PeriodType', {
        is: 'M',
        then: (schema) => schema.max(99),
    })
        .when('PeriodType', {
        is: 'Y',
        then: (schema) => schema.max(9),
    }),
    PeriodReturnURL: yup.string().max(200).url(),
});
const ALLPaymentParamsSchema = yup
    .object()
    .shape({
    IgnorePayment: yup
        .array()
        .of(yup
        .string()
        .strict()
        .oneOf(['Credit', 'WebATM', 'ATM', 'CVS', 'BARCODE', 'AndroidPay'])),
    ExpireDate: yup.number().integer().strict().min(1).max(60),
    PaymentInfoURL: yup.string().max(200).url(),
    ClientRedirectURL: yup.string().max(200).url(),
    StoreExpireDate: yup.number().integer().strict().min(1).max(30),
    Desc_1: yup.string().strict().max(20),
    Desc_2: yup.string().strict().max(20),
    Desc_3: yup.string().strict().max(20),
    Desc_4: yup.string().strict().max(20),
})
    .concat(CreditBasePaymentParamsSchema_1.default)
    .concat(CreditOneTimePaymentParamsSchema_1.default)
    .concat(_CreditDividePaymentParamsSchema)
    .concat(_CreditPeriodPaymentParamsSchema);
exports.default = ALLPaymentParamsSchema;
